#include <iostream>
#include <vector>
#include "graph.h"
//edges are stored as a list for each node

//construct an edge
MyEdge::MyEdge(MyNode* m,std::string label)
{
	edgeLabel=label;
	secondNode=m;
}

//gets the node being pointed to by the edge
MyNode* MyEdge::getNode()const
{
	return secondNode;
}

//sets the node being pointed to
void MyEdge::setNode(MyNode* m)
{
	secondNode=m;
	
}
//gets the label of the edge (if edge labels are enabled)
std::string MyEdge::getEdgeLabel()const
{
	return edgeLabel;
}