#ifndef _INDEXINGVALUE_H
#define _INDEXINGVALUE_H
#include <map>
#include <string>
class edgeDescriptor
{
public:
	edgeDescriptor(){};
	edgeDescriptor(char d,unsigned short t,std::string l)
		{direction=d;type=t;label=l;};
	char direction;
	unsigned short type;
	std::string label;
	bool operator<(const edgeDescriptor& E) const
		{if(direction!=E.direction){return direction<E.direction;}
		if(type!=E.type){return type<E.type;}
		return label.compare(E.label)<0;};
};

class IndexingValue
{
public:
	//constructor
	IndexingValue(){};
	//modifiers
	void addToValue(const edgeDescriptor& E, float count);
	void setIDegree(std::map<edgeDescriptor, float>& D){iDegree=D;};
	//accessors
	std::map<edgeDescriptor, float>* getIDegree();
private:
	std::map<edgeDescriptor, float> iDegree;
};


#endif