#include <iostream>
#include <fstream>
#include <algorithm>
#include "utilities.h"
#include "graph.h"
#include "scorer.h"

Scorer::Scorer(std::vector< std::pair<double, std::map<unsigned int, unsigned int> > > c, char method, float value)
{//takes as arguments a set of candidates
	
}

void Scorer::anchorMethod(std::vector< std::pair<double, std::map<unsigned int, unsigned int> > > c, unsigned int anchorID)
{
	unsigned int resultNum=0;
	for(std::vector< std::pair<double, std::map<unsigned int, unsigned int> > >::iterator itr=c.begin();itr!=c.end();itr++)
	{//for each candidate mapping
		std::map<unsigned int, unsigned int>::iterator nodeItr=itr->second.find(anchorID);
		//check anchor only
		if(nodeItr!=itr->second.end()){
			if(nodeItr->first==nodeItr->second)
			{
				fprintf(stdout,"%d\n",resultNum);
				return;
			}
		}
		resultNum++;
	}
	fprintf(stdout,"-1\n");//failed to locate a success
}

void Scorer::overlapMethod(std::vector< std::pair<double, std::map<unsigned int, unsigned int> > > c, float value)
{
	unsigned int resultNum=0;
	for(std::vector< std::pair<double, std::map<unsigned int, unsigned int> > > ::iterator itr=c.begin();itr!=c.end();itr++)
	{//for each candidate mapping
		float score=0;
		for(std::map<unsigned int, unsigned int>::iterator nodeItr=itr->second.begin();
			nodeItr!=itr->second.end();nodeItr++)
		{//for each node
			if(nodeItr->first==nodeItr->second)
			{
				score+=1;
			}
		}
		score/=itr->second.size();
		if(score>value)
		{
			fprintf(stdout,"%d\t%f\n",resultNum,score);
			return;
		}
		resultNum++;
	}
	fprintf(stdout,"-1\t0\n");//failed to locate a success
}