#ifndef STATS_H
#define STATS_H
#include <map>

class stats_keeper 
{
public:
	void update(double d);

	double getMode()const; 
	double getAverage()const; 
	double getStdDev()const; 
	unsigned int getSampleSize()const; 
	double getMedian()const; 
	double getMin()const; 
	double getMax()const; 
private:
	std::map<double, unsigned int> countNumbers;
};

#endif
